#include "client.h"

static void
login(FILE *s, int password)
{
  fprintf(s, ":listener \"listener.c PID %d\" %d\n", getpid(), password);
  fprintf(s, "-%d\n", getpid());
  fflush(s);
}

int
main(int argc, char **argv)
{
  int port, password;
  FILE *s;
  
  puts(read_configuration(&port, &password));
  fflush(stdout);
  s = do_connect(port);
  login(s, password);

# define MAXBUF 1024
  {
    char buf[MAXBUF];
    int n;
    struct pollfd fds[2];
    int nfds = 2;

    fds[0].fd = fileno(s);
    fds[0].events = POLLIN;
    fds[1].fd = 0;
    fds[1].events = POLLIN;
    for (;;) {
      fds[0].revents = fds[1].revents = 0;
      if (poll(fds, nfds, -1) < 0) syserr();
      if (fds[0].revents) {
	if ( (n = read(fds[0].fd, buf, sizeof(buf))) < 0) syserr();
	if (n == 0) break;
	if (write(1, buf, n) != n) syserr();
      }
      if (fds[1].revents) {
	if ( (n = read(fds[1].fd, buf, sizeof(buf))) < 0) syserr();
	if (!n) {
	  nfds--;
	  shutdown(fds[0].fd, SHUT_WR);
	} else
	  if (write(fds[0].fd, buf, n) != n) syserr();
      }
    }
  }
  return 0;
}
